diff -pruN 0.9.5-5.1/configure.ac 0.9.5-5.1ubuntu4/configure.ac
--- 0.9.5-5.1/configure.ac	2009-10-18 11:50:39.000000000 +0000
+++ 0.9.5-5.1ubuntu4/configure.ac	2015-04-03 12:36:27.000000000 +0000
@@ -17,12 +17,36 @@ AM_GNU_GETTEXT_VERSION([0.16])
 #PKG_CHECK_MODULES(GNOME_KEYRING, gnome-keyring-1, CFLAGS="$CFLAGS -DUSE_GNOME_KEYRING", echo "Gnome Keyring support disabled")
 PKG_CHECK_MODULES(DEP, gtk+-2.0 >= 2.8 gconf-2.0)
 
+APPINDICATOR_REQUIRED=0.4.92
+
+AC_ARG_ENABLE(appindicator,
+                        AS_HELP_STRING([--enable-appindicator[=@<:@no/auto/yes@:>@]],[Build support for application indicators ]),
+                        [enable_appindicator=$enableval],
+                        [enable_appindicator="auto"])
+
+if test x$enable_appindicator = xauto ; then
+        PKG_CHECK_EXISTS([appindicator-0.1 >= $APPINDICATOR_REQUIRED],
+                         enable_appindicator="yes",
+                         enable_appindicator="no")
+fi
+
+if test x$enable_appindicator = xyes ; then
+        PKG_CHECK_EXISTS([appindicator-0.1 >= $APPINDICATOR_REQUIRED],,
+                         AC_MSG_ERROR([appindicator-0.1 is not installed]))
+        PKG_CHECK_MODULES(APP_INDICATOR,
+                        appindicator-0.1 >= $APPINDICATOR_REQUIRED)
+        AC_SUBST(APP_INDICATOR_CFLAGS)
+        AC_SUBST(APP_INDICATOR_LIBS)
+        AC_DEFINE(HAS_APP_INDICATOR, 1, [Has AppIndicator])
+fi
+AM_CONDITIONAL(HAS_APP_INDICATOR, test x"$enable_appindicator" = xyes)
+
 #AC_SUBST(DEP_CFLAGS)
 #AC_SUBST(DEP_LIBS)
 
-CFLAGS="$CFLAGS $DEP_CFLAGS $GNOME_KEYRING_CFLAGS"
+CFLAGS="$CFLAGS $DEP_CFLAGS $GNOME_KEYRING_CFLAGS $APP_INDICATOR_CFLAGS"
 CXXFLAGS="$CFLAGS"
-LIBS="$DEP_LIBS $GNOME_KEYRING_LIBS"
+LIBS="$DEP_LIBS $GNOME_KEYRING_LIBS -lX11 $APP_INDICATOR_LIBS"
 
 #AC_PROG_LIBTOOL
 
diff -pruN 0.9.5-5.1/debian/changelog 0.9.5-5.1ubuntu4/debian/changelog
--- 0.9.5-5.1/debian/changelog	2012-05-15 15:10:31.000000000 +0000
+++ 0.9.5-5.1ubuntu4/debian/changelog	2015-04-03 10:48:00.000000000 +0000
@@ -1,3 +1,34 @@
+cryptkeeper (0.9.5-5.1ubuntu4) vivid; urgency=medium
+
+  * debian/patches/add_support_for_appindicator.patch:
+    - removed unused and uninitialized widget (fixes GTK critical warning).
+      (lp: #1420812)
+
+ -- Vlad Orlov <monsta@inbox.ru>  Wed, 11 Feb 2015 16:16:29 +0300
+
+cryptkeeper (0.9.5-5.1ubuntu3) trusty; urgency=low
+
+  * No change rebuild. It should fix some random segfaults.
+
+ -- Alberto Milone <alberto.milone@canonical.com>  Mon, 04 Nov 2013 19:15:13 +0100
+
+cryptkeeper (0.9.5-5.1ubuntu2) saucy; urgency=low
+
+  * debian/patches/add_support_for_appindicator.patch:
+    - Fix FTBFS on i386.
+
+ -- Alberto Milone <alberto.milone@canonical.com>  Mon, 13 May 2013 13:29:45 +0200
+
+cryptkeeper (0.9.5-5.1ubuntu1) saucy; urgency=low
+
+  * debian/patches/add_support_for_appindicator.patch:
+    - Add support for Appindicator (LP: #571473).
+    - Fix a linker issue (-lX11 was missing).
+  * debian/rules:
+    - Pass flag to build with appindicator support.
+
+ -- Alberto Milone <alberto.milone@canonical.com>  Sun, 12 May 2013 17:59:14 +0200
+
 cryptkeeper (0.9.5-5.1) unstable; urgency=low
 
   * Non-maintainer upload.
diff -pruN 0.9.5-5.1/debian/control 0.9.5-5.1ubuntu4/debian/control
--- 0.9.5-5.1/debian/control	2011-12-12 20:55:47.000000000 +0000
+++ 0.9.5-5.1ubuntu4/debian/control	2013-05-13 11:36:35.000000000 +0000
@@ -2,14 +2,14 @@ Source: cryptkeeper
 Section: admin
 Priority: optional
 Maintainer: Francesco Namuri <francesco@namuri.it>
-Build-Depends: cdbs, debhelper (>= 5), autotools-dev, libgtk2.0-dev (>= 2.8), libgconf2-dev, imagemagick, patchutils, gettext
+Build-Depends: cdbs, debhelper (>= 5), autotools-dev, libgtk2.0-dev (>= 2.8), libgconf2-dev, imagemagick, patchutils, gettext, libappindicator-dev
 Standards-Version: 3.9.2
 Homepage: http://tom.noflag.org.uk/cryptkeeper.html
 DM-Upload-Allowed:yes
 
 Package: cryptkeeper
 Architecture: linux-any kfreebsd-any
-Depends: ${shlibs:Depends}, ${misc:Depends}, zenity, fuse [linux-any], encfs
+Depends: ${shlibs:Depends}, ${misc:Depends}, zenity, fuse [linux-any], encfs, libappindicator3-1
 Description: EncFS system tray applet for GNOME
  An encrypted folders manager, it allows users to mount and unmount encfs
  folders, to change the password and to create new crypted folders. It
diff -pruN 0.9.5-5.1/debian/patches/add_support_for_appindicator.patch 0.9.5-5.1ubuntu4/debian/patches/add_support_for_appindicator.patch
--- 0.9.5-5.1/debian/patches/add_support_for_appindicator.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.9.5-5.1ubuntu4/debian/patches/add_support_for_appindicator.patch	2015-04-03 10:47:38.000000000 +0000
@@ -0,0 +1,800 @@
+From 822b11c750eb7b8d5b213a6f7daffa042c029d17 Mon Sep 17 00:00:00 2001
+From: Alberto Milone <alberto.milone@canonical.com>
+Date: Tue, 26 Mar 2013 12:01:23 +0100
+Subject: [PATCH 1/1] Add support for appindicator
+
+---
+ configure.ac            |   28 ++-
+ src/ImportStashWizard.h |    4 +-
+ src/main.cpp            |  625 ++++++++++++++++++++++++++++++++++++++++++++++-
+ 3 files changed, 651 insertions(+), 6 deletions(-)
+
+Index: cryptkeeper-0.9.5/configure.ac
+===================================================================
+--- cryptkeeper-0.9.5.orig/configure.ac
++++ cryptkeeper-0.9.5/configure.ac
+@@ -17,12 +17,36 @@ AM_GNU_GETTEXT_VERSION([0.16])
+ #PKG_CHECK_MODULES(GNOME_KEYRING, gnome-keyring-1, CFLAGS="$CFLAGS -DUSE_GNOME_KEYRING", echo "Gnome Keyring support disabled")
+ PKG_CHECK_MODULES(DEP, gtk+-2.0 >= 2.8 gconf-2.0)
+ 
++APPINDICATOR_REQUIRED=0.4.92
++
++AC_ARG_ENABLE(appindicator,
++                        AS_HELP_STRING([--enable-appindicator[=@<:@no/auto/yes@:>@]],[Build support for application indicators ]),
++                        [enable_appindicator=$enableval],
++                        [enable_appindicator="auto"])
++
++if test x$enable_appindicator = xauto ; then
++        PKG_CHECK_EXISTS([appindicator-0.1 >= $APPINDICATOR_REQUIRED],
++                         enable_appindicator="yes",
++                         enable_appindicator="no")
++fi
++
++if test x$enable_appindicator = xyes ; then
++        PKG_CHECK_EXISTS([appindicator-0.1 >= $APPINDICATOR_REQUIRED],,
++                         AC_MSG_ERROR([appindicator-0.1 is not installed]))
++        PKG_CHECK_MODULES(APP_INDICATOR,
++                        appindicator-0.1 >= $APPINDICATOR_REQUIRED)
++        AC_SUBST(APP_INDICATOR_CFLAGS)
++        AC_SUBST(APP_INDICATOR_LIBS)
++        AC_DEFINE(HAS_APP_INDICATOR, 1, [Has AppIndicator])
++fi
++AM_CONDITIONAL(HAS_APP_INDICATOR, test x"$enable_appindicator" = xyes)
++
+ #AC_SUBST(DEP_CFLAGS)
+ #AC_SUBST(DEP_LIBS)
+ 
+-CFLAGS="$CFLAGS $DEP_CFLAGS $GNOME_KEYRING_CFLAGS"
++CFLAGS="$CFLAGS $DEP_CFLAGS $GNOME_KEYRING_CFLAGS $APP_INDICATOR_CFLAGS"
+ CXXFLAGS="$CFLAGS"
+-LIBS="$DEP_LIBS $GNOME_KEYRING_LIBS"
++LIBS="$DEP_LIBS $GNOME_KEYRING_LIBS -lX11 $APP_INDICATOR_LIBS"
+ 
+ #AC_PROG_LIBTOOL
+ 
+Index: cryptkeeper-0.9.5/src/ImportStashWizard.h
+===================================================================
+--- cryptkeeper-0.9.5.orig/src/ImportStashWizard.h
++++ cryptkeeper-0.9.5/src/ImportStashWizard.h
+@@ -7,12 +7,12 @@ class ImportStashWizard {
+ 	void Hide ();
+ 	void Restart ();
+ 	void GoBack ();
+-	void GoForward ();
++	virtual void GoForward ();
+ 	ImportStashWizard ();
+ 	virtual ~ImportStashWizard ();
+ 	
+ 	GtkWidget *m_window;
+-	private:
++	protected:
+ 	enum WizardStage {
+ 		WIZ_START,
+ 		WIZ_PASSWD,
+Index: cryptkeeper-0.9.5/src/main.cpp
+===================================================================
+--- cryptkeeper-0.9.5.orig/src/main.cpp
++++ cryptkeeper-0.9.5/src/main.cpp
+@@ -43,6 +43,9 @@
+ # include "gtkstatusicon.h"
+ #endif
+ 
++#ifdef HAS_APP_INDICATOR
++#include <libappindicator/app-indicator.h>
++#endif
+ 
+ class CryptPoint {
+ 	private:
+@@ -65,13 +68,58 @@ class CryptPoint {
+ 	void SetIsAvailable (bool b) { isAvailable = b; }
+ };
+ 
++#ifdef HAS_APP_INDICATOR
++class EditDialog {
++  public:
++  void Initialise ();
++  void Show ();
++  void Hide ();
++  EditDialog ();
++  virtual ~EditDialog ();
++
++  GtkWidget *m_window;
++    GtkWidget *m_view;
++    GtkWidget *m_vbox;
++    GtkWidget *m_hbox;
++    GtkWidget *m_buttonbox;
++    GtkWidget *m_sidebuttonbox;
++    GtkWidget *m_button_information;
++    GtkWidget *m_button_password;
++    GtkWidget *m_button_cancel;
++    GtkWidget *m_button_delete;
++    GtkWidget *m_label;
++    GtkTreeSelection *m_selection;
++    GtkTreeModel *m_model;
++    GtkListStore *m_store;
++  private:
++};
++
++class ImportStashWizardMod : public ImportStashWizard {
++  public:
++  void Refresh ();
++  void GoForward ();
++};
++
++static void update_view (GtkWidget *m_view);
++
++static EditDialog *edit_dialog;
++#endif
+ static GtkStatusIcon *sico;
+ static std::vector<CryptPoint> cryptPoints;
+ static CreateStashWizard *create_stash_wizard;
++#ifdef HAS_APP_INDICATOR
++static ImportStashWizardMod *import_stash_wizard;
++#else
+ static ImportStashWizard *import_stash_wizard;
++#endif
+ static ConfigDialog *config_dialog;
+ static GConfClient *gconf_client;
+ 
++#ifdef HAS_APP_INDICATOR
++static AppIndicator *indicator;
++static void refresh_menu (void);
++#endif
++
+ char *config_filemanager;
+ int config_idletime;
+ bool config_keep_mountpoints;
+@@ -300,6 +348,9 @@ static void on_mount_check_item_toggled
+ 			}
+ 		}
+ 	}
++#ifdef HAS_APP_INDICATOR
++	refresh_menu();
++#endif
+ }
+ 
+ static void on_import_stash_clicked (GtkWidget *blah)
+@@ -312,7 +363,7 @@ static void on_create_new_stash_clicked
+ 	create_stash_wizard->Show ();
+ }
+ 
+-static GtkWidget *stashes_popup_menu;
++static GtkWidget *stashes_popup_menu = NULL;
+ 
+ static bool on_dostuff_menu_destroy ()
+ {
+@@ -344,6 +395,30 @@ gboolean on_click_stash_info (GtkMenuIte
+ 	return FALSE;
+ }
+ 
++#ifdef HAS_APP_INDICATOR
++gboolean get_stash_info (int idx)
++{
++	if (test_crypt_dir_and_moan (cryptPoints[idx].GetCryptDir ())) return FALSE;
++
++	char *msg;
++	encfs_stash_get_info (cryptPoints[idx].GetCryptDir (), &msg);
++	if (msg) {
++		GtkWidget *dialog = gtk_message_dialog_new (NULL,
++				GTK_DIALOG_MODAL,
++				GTK_MESSAGE_INFO,
++				GTK_BUTTONS_CLOSE,
++				_("Crypt directory: %s\nMount directory: %s\n%s"),
++				cryptPoints[idx].GetCryptDir (),
++				cryptPoints[idx].GetMountDir (),
++				msg);
++		gtk_window_set_title (GTK_WINDOW (dialog), "Information");
++		gtk_dialog_run (GTK_DIALOG (dialog));
++		gtk_widget_destroy (dialog);
++		free (msg);
++	}
++	return FALSE;
++}
++#endif
+ 
+ gboolean on_click_change_stash_password (GtkMenuItem *mi, gpointer data)
+ {
+@@ -401,6 +476,60 @@ gboolean on_click_delete_stash (GtkMenuI
+ 	return FALSE;
+ }
+ 
++#ifdef HAS_APP_INDICATOR
++gboolean change_stash_password (int idx)
++{
++	if (test_crypt_dir_and_moan (cryptPoints[idx].GetCryptDir ())) return FALSE;
++
++	PasswordChangeDialog *dialog = new PasswordChangeDialog (cryptPoints[idx].GetCryptDir (),
++			cryptPoints[idx].GetMountDir ());
++	dialog->Show ();
++	return TRUE;
++}
++
++gboolean delete_stash (int idx)
++{
++	GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
++			GTK_DIALOG_MODAL,
++			GTK_MESSAGE_QUESTION,
++			GTK_BUTTONS_OK_CANCEL,
++			"<span weight=\"bold\" size=\"larger\">%s\n\n%s</span>",
++			_("Are you sure you want to remove the encrypted folder:"),
++			cryptPoints[idx].GetMountDir ());
++	int result = gtk_dialog_run (GTK_DIALOG (dialog));
++	gtk_widget_destroy (dialog);
++	if (result != GTK_RESPONSE_OK) return FALSE;
++
++	if (!unmount_cryptpoint (idx)) {
++		// fuck. can't unmount
++		moan_cant_unmount (cryptPoints[idx].GetMountDir());
++	} else {
++		GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
++				GTK_DIALOG_MODAL,
++				GTK_MESSAGE_WARNING,
++				GTK_BUTTONS_YES_NO,
++				"<span weight=\"bold\" size=\"larger\">%s\n\n%s</span>",
++				_("Do you want to permanently erase the encrypted data:"),
++				cryptPoints[idx].GetCryptDir ());
++		int result = gtk_dialog_run (GTK_DIALOG (dialog));
++		gtk_widget_destroy (dialog);
++
++		if (result != GTK_RESPONSE_YES) {
++			cryptPoints.erase (cryptPoints.begin () + idx);
++		} else {
++			// recursive delete is tedious to implement ;)
++			char buf[1024];
++			snprintf (buf, sizeof (buf), "rm -rf \"%s\"", cryptPoints[idx].GetCryptDir ());
++			system (buf);
++			cryptPoints.erase (cryptPoints.begin () + idx);
++		}
++		write_config ();
++	}
++
++	return TRUE;
++}
++#endif
++
+ gboolean on_button_release (GtkWidget *widget, GdkEventButton *event, gpointer data)
+ {
+ 	int item_no = GPOINTER_TO_INT (data);
+@@ -440,6 +569,15 @@ static void open_config_dialog ()
+ 	config_dialog->Show ();
+ }
+ 
++#ifdef HAS_APP_INDICATOR
++static void open_edit_dialog ()
++{
++	edit_dialog->Hide ();
++	edit_dialog->Initialise ();
++	edit_dialog->Show ();
++}
++#endif
++
+ static void open_about_dialog ()
+ {
+ 	GtkWidget *dialog = gtk_about_dialog_new ();
+@@ -455,6 +593,7 @@ static void open_about_dialog ()
+ 	gtk_widget_destroy (dialog);
+ }
+ 
++#ifndef HAS_APP_INDICATOR
+ static void sico_right_button_activated ()
+ {
+ 	GtkWidget *menu = gtk_menu_new ();
+@@ -476,7 +615,100 @@ static void sico_right_button_activated
+ 	gtk_menu_popup (GTK_MENU (menu), NULL, NULL, gtk_status_icon_position_menu, sico,
+ 			0, gtk_get_current_event_time ());
+ }
++#endif
++
++#ifdef HAS_APP_INDICATOR
++static void refresh_menu (void)
++{
++	if (stashes_popup_menu)
++		gtk_widget_destroy (stashes_popup_menu);
++
++	stashes_popup_menu = gtk_menu_new ();
++
++	GtkWidget *mi = gtk_menu_item_new ();
++	GtkWidget *w = gtk_label_new (NULL);
++	gtk_label_set_markup (GTK_LABEL (w), _("<b>Encrypted folders:</b>"));
++	gtk_container_add (GTK_CONTAINER (mi), w);
++	gtk_widget_set_sensitive (mi, FALSE);
++	gtk_menu_append (stashes_popup_menu, mi);
++
++	int i = 0;
++	std::vector<CryptPoint>::iterator it;
++	// find out which ones are mounted
++	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it, i++) {
++		struct stat s;
++
++		(*it).SetIsMounted (false);
++		(*it).SetIsAvailable (false);
++
++		if (stat ((*it).GetCryptDir (), &s) != -1) {
++			if (S_ISDIR (s.st_mode)) (*it).SetIsAvailable (true);
++		}
++
++		// to get rid of festering mount points
++		if (!config_keep_mountpoints) rmdir ((*it).GetMountDir ());
++
++		if (is_mounted((*it).GetMountDir())) {
++			if (S_ISDIR (s.st_mode)) (*it).SetIsMounted (true);
++		}
++	}
++
++	i = 0;
++	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it, i++) {
++		mi = gtk_check_menu_item_new ();
++		char buf[256];
++		if ((*it).GetIsAvailable ()) {
++			snprintf (buf, sizeof (buf), "%s", (*it).GetMountDir ());
++		} else {
++			snprintf (buf, sizeof (buf), "<span foreground=\"grey\">%s</span>", (*it).GetMountDir ());
++		}
++		GtkWidget *label = gtk_label_new (NULL);
++		gtk_label_set_markup (GTK_LABEL (label), buf);
++		gtk_container_add (GTK_CONTAINER (mi), label);
++		gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (mi), (*it).GetIsMounted ());
++		//gtk_widget_set_sensitive (mi, (*it).GetIsAvailable ());
++		gtk_menu_append (stashes_popup_menu, mi);
++		g_signal_connect (G_OBJECT (mi), "toggled", G_CALLBACK (on_mount_check_item_toggled), GINT_TO_POINTER (i));
++	}
++
++	mi = gtk_separator_menu_item_new ();
++	gtk_menu_append (stashes_popup_menu, mi);
++
++	mi = gtk_menu_item_new_with_label (_("Import EncFS folder"));
++	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_import_stash_clicked), NULL);
++	gtk_menu_append (stashes_popup_menu, mi);
++
++	mi = gtk_menu_item_new_with_label (_("New encrypted folder"));
++	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_create_new_stash_clicked), NULL);
++	gtk_menu_append (stashes_popup_menu, mi);
++
++	mi = gtk_separator_menu_item_new ();
++	gtk_menu_append (stashes_popup_menu, mi);
++
++	/* previous right click code */
++	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_EDIT, NULL);
++	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_edit_dialog), NULL);
++	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
++
++	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_PREFERENCES, NULL);
++	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_config_dialog), NULL);
++	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
++
++	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_ABOUT, NULL);
++	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_about_dialog), NULL);
++	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
++
++	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_QUIT, NULL);
++	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (gtk_exit), NULL);
++	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
++
++	gtk_widget_show_all (stashes_popup_menu);
++
++	app_indicator_set_menu (indicator, GTK_MENU (stashes_popup_menu));
++}
++#endif
+ 
++#ifndef HAS_APP_INDICATOR
+ static void sico_activated (GtkWidget *data)
+ {
+ 	stashes_popup_menu = gtk_menu_new ();
+@@ -544,6 +776,7 @@ static void sico_activated (GtkWidget *d
+ 	gtk_menu_popup (GTK_MENU (stashes_popup_menu), NULL, NULL, gtk_status_icon_position_menu, sico,
+ 			0, gtk_get_current_event_time ());
+ }
++#endif
+ 
+ #define CONF_DIR "/apps/cryptkeeper"
+ #define CONF_PATH_FILEMANAGER "/apps/cryptkeeper/filemanager"
+@@ -657,6 +890,375 @@ static void on_change_conf_stashes (GCon
+ 	read_config ();
+ }
+ 
++#ifdef HAS_APP_INDICATOR
++enum
++{
++  COL_NAME = 0,
++  COL_AGE,
++  NUM_COLS
++} ;
++
++#define UI_SPACING 0
++
++static gboolean on_edit_window_close (GtkWidget *window, GdkEvent *event, EditDialog *dialog)
++{
++  dialog->Hide ();
++  return TRUE;
++}
++
++static void on_edit_cancel_clicked (GtkButton *button, EditDialog *dialog)
++{
++  dialog->Hide ();
++}
++
++static gboolean is_any_row_selected (GtkTreeView *treeview)
++{
++  GtkTreeSelection *selection;
++  GtkTreeModel     *model;
++  GtkTreeIter       iter;
++
++  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
++  return (gtk_tree_selection_get_selected(selection, &model, &iter));
++}
++
++static void on_information_clicked (GtkButton *button, GtkWidget *widget)
++{
++  GtkTreeSelection *selection;
++  GtkTreeModel     *model;
++  GtkTreeIter       iter;
++  GtkTreePath *path;
++  int index;
++  /* This will only work in single or browse selection mode! */
++
++  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(widget));
++  if (gtk_tree_selection_get_selected(selection, &model, &iter))
++  {
++    path = gtk_tree_model_get_path (model, &iter);
++    index = (int) gtk_tree_path_get_indices (path)[0];
++    /* Show the dialog */
++    get_stash_info (index);
++  }
++}
++
++static void on_delete_clicked (GtkButton *button, GtkWidget *widget)
++{
++  GtkTreeSelection *selection;
++  GtkTreeModel     *model;
++  GtkTreeIter       iter;
++  GtkTreePath *path;
++  int index;
++  /* This will only work in single or browse selection mode! */
++
++  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(widget));
++  if (gtk_tree_selection_get_selected (selection, &model, &iter))
++  {
++    path = gtk_tree_model_get_path (model, &iter);
++    index = (int) gtk_tree_path_get_indices (path)[0];
++
++    /* delete_stash and remove from the tree */
++    if (delete_stash (index))
++    {
++      /* Remove the dir at index */
++      gtk_list_store_remove (GTK_LIST_STORE(model), &iter);
++      gtk_widget_set_sensitive (gtk_widget_get_parent((GtkWidget *) button), FALSE);
++
++      /* Refresh the indicator */
++      refresh_menu ();
++
++      /* Update the Treeview */
++      update_view (widget);
++    }
++  }
++}
++
++static void on_change_password_clicked (GtkButton *button, GtkWidget *widget)
++{
++  GtkTreeSelection *selection;
++  GtkTreeModel     *model;
++  GtkTreeIter       iter;
++  GtkTreePath *path;
++  int index;
++  /* This will only work in single or browse selection mode! */
++
++  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(widget));
++  if (gtk_tree_selection_get_selected(selection, &model, &iter))
++  {
++    path = gtk_tree_model_get_path (model, &iter);
++    index = (int) gtk_tree_path_get_indices (path)[0];
++
++    change_stash_password (index);
++  }
++}
++
++/* Make the buttonbox sensitive when the cursor is on a row */
++static void on_row_selected (GtkWidget *widget, EditDialog *dialog)
++{
++  if (is_any_row_selected((GtkTreeView *) dialog->m_view))
++  {
++    gtk_widget_set_sensitive (dialog->m_sidebuttonbox, TRUE);
++  }
++}
++
++static void
++add_row (GtkListStore * store, const gchar *dir)
++{
++  GtkTreeIter    iter;
++  /* Append a row and fill in some data */
++  gtk_list_store_append (store, &iter);
++  gtk_list_store_set (store, &iter,
++                      COL_NAME, dir,
++                      -1);
++}
++
++
++static GtkTreeModel *
++create_and_fill_model (void)
++{
++  GtkListStore  *store;
++
++  store = gtk_list_store_new (1, G_TYPE_STRING, G_TYPE_UINT);
++
++  return GTK_TREE_MODEL (store);
++}
++
++static GtkWidget *
++create_view_and_model (void)
++{
++  GtkCellRenderer     *renderer;
++  GtkTreeModel        *model;
++  GtkWidget           *view;
++
++  view = gtk_tree_view_new ();
++
++  /* --- Column #1 --- */
++  renderer = gtk_cell_renderer_text_new ();
++  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (view),
++                                               -1,
++                                               "Name",
++                                               renderer,
++                                               "text", COL_NAME,
++                                               NULL);
++  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (view), FALSE);
++
++  model = create_and_fill_model ();
++
++  gtk_tree_view_set_model (GTK_TREE_VIEW (view), model);
++
++  /* The tree view has acquired its own reference to the
++   *  model, so we can drop ours. This way the model will
++   *  be freed automatically when the tree view is destroyed */
++  g_object_unref (model);
++
++  return view;
++}
++
++EditDialog::~EditDialog ()
++{
++  gtk_widget_destroy (m_window);
++}
++
++void EditDialog::Show ()
++{
++  gtk_widget_show_all (m_window);
++}
++
++void EditDialog::Hide ()
++{
++  gtk_widget_destroy (m_window);
++}
++
++static void update_treemodel (GtkTreeModel *model) {
++  gtk_list_store_clear (GTK_LIST_STORE (model));
++
++  std::vector<CryptPoint>::iterator it;
++    for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it) {
++      add_row (GTK_LIST_STORE(model), (*it).GetMountDir() );
++    }
++}
++
++static void update_view (GtkWidget *m_view)
++{
++  /* Refresh view */
++  GtkTreeModel *model;
++  GtkTreePath *path;
++  GtkTreeSelection *selection;
++
++  if (m_view)
++    {
++    model = gtk_tree_view_get_model (GTK_TREE_VIEW (m_view));
++
++    /* Clear and update the model */
++    update_treemodel (model);
++
++	/* Select the first row */
++	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(m_view));
++    path = gtk_tree_path_new_first();
++    gtk_tree_selection_select_path(selection, path);
++    gtk_tree_path_free (path);
++    }
++}
++
++void EditDialog::Initialise ()
++{
++  m_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
++  gtk_window_set_position (GTK_WINDOW(m_window), GTK_WIN_POS_CENTER_ALWAYS);
++  gtk_container_set_border_width (GTK_CONTAINER (m_window), 12);
++  g_signal_connect(G_OBJECT(m_window), "delete-event", G_CALLBACK(on_edit_window_close), this);
++
++    /* main_m_vbox */
++  m_vbox = gtk_vbox_new (FALSE, 12); //UI_SPACING);
++  gtk_container_set_border_width (GTK_CONTAINER (m_vbox), 0);
++  //gtk_container_add(GTK_CONTAINER(main_alignment), m_vbox);
++  gtk_container_add(GTK_CONTAINER(m_window), m_vbox);
++
++      /* m_label */
++  m_label = gtk_label_new (_("Select one of the following encrypted folders:"));
++      /* horizontal : left, vertical : centered */
++  gtk_misc_set_alignment (GTK_MISC(m_label), 0.0f, 0.5f);
++  gtk_misc_set_padding (GTK_MISC(m_label), 12, 0);
++  gtk_box_pack_start (GTK_BOX (m_vbox), m_label, FALSE, FALSE, UI_SPACING);
++
++    /* m_hbox */
++  m_hbox = gtk_hbox_new (FALSE, UI_SPACING);
++  gtk_container_set_border_width (GTK_CONTAINER (m_hbox), 0);
++  //gtk_misc_set_padding (GTK_MISC(m_hbox), 12, 0);
++  gtk_box_pack_start (GTK_BOX (m_vbox), m_hbox, FALSE, FALSE, UI_SPACING);
++      /* treeview */
++  m_model = NULL;
++  m_view = NULL;
++
++  m_view = create_view_and_model ();
++
++  /* Only one selection */
++  m_selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m_view));
++  gtk_tree_selection_set_mode(m_selection, GTK_SELECTION_SINGLE);
++  //gtk_tree_selection_select_iter(m_selection, 0);
++
++  gtk_box_pack_start (GTK_BOX (m_hbox), m_view, TRUE, TRUE, UI_SPACING);
++
++      /* m_sidebuttonbox */
++  m_sidebuttonbox = gtk_vbutton_box_new ();
++  m_button_information = gtk_button_new_from_stock (GTK_STOCK_INFO);
++  g_signal_connect (G_OBJECT (m_button_information), "clicked", G_CALLBACK (on_information_clicked), m_view);
++  gtk_widget_set_sensitive (m_sidebuttonbox, FALSE);
++
++  m_button_password = gtk_button_new_with_label(_("Change Password"));
++  m_button_delete = gtk_button_new_from_stock (GTK_STOCK_DELETE);
++
++  gtk_box_pack_start (GTK_BOX (m_sidebuttonbox), m_button_information, FALSE, FALSE, UI_SPACING);
++  gtk_box_pack_start (GTK_BOX (m_sidebuttonbox), m_button_password, FALSE, FALSE, UI_SPACING);
++  gtk_box_pack_start (GTK_BOX (m_sidebuttonbox), m_button_delete, FALSE, FALSE, UI_SPACING);
++  gtk_button_box_set_layout ((GtkButtonBox *) m_sidebuttonbox, GTK_BUTTONBOX_START);
++  gtk_box_pack_start (GTK_BOX (m_hbox),m_sidebuttonbox, FALSE, FALSE, UI_SPACING);
++
++    /* hButtonBox */
++  m_buttonbox = gtk_hbutton_box_new ();
++  gtk_container_set_border_width (GTK_CONTAINER (m_hbox), 0);
++  m_button_cancel = gtk_button_new_from_stock (GTK_STOCK_CANCEL);
++  g_signal_connect (G_OBJECT (m_button_cancel), "clicked", G_CALLBACK (on_edit_cancel_clicked), this);
++  g_signal_connect (G_OBJECT (m_button_delete), "clicked", G_CALLBACK (on_delete_clicked), m_view);
++  g_signal_connect (G_OBJECT (m_button_password), "clicked", G_CALLBACK (on_change_password_clicked), m_view);
++
++  gtk_box_pack_end (GTK_BOX (m_buttonbox), m_button_cancel, FALSE, FALSE, UI_SPACING);
++  gtk_button_box_set_layout ((GtkButtonBox *) m_buttonbox, GTK_BUTTONBOX_END);
++  gtk_box_pack_end (GTK_BOX (m_vbox), m_buttonbox, FALSE, FALSE, UI_SPACING);
++
++
++  g_signal_connect (G_OBJECT (m_view), "cursor-changed", G_CALLBACK (on_row_selected), this);
++
++  gtk_window_set_resizable((GtkWindow *) m_window, FALSE);
++
++
++  update_view (m_view);
++}
++
++EditDialog::EditDialog ()
++{
++  Initialise ();
++}
++
++void ImportStashWizardMod::Refresh ()
++{
++	refresh_menu ();
++}
++
++void ImportStashWizardMod::GoForward ()
++{
++	if (m_stage == WIZ_START) {
++		m_crypt_dir = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (m_magic));
++		if (m_crypt_dir == NULL) {
++			GtkWidget *dialog = 
++				gtk_message_dialog_new_with_markup (GTK_WINDOW (m_window),
++						GTK_DIALOG_MODAL,
++						GTK_MESSAGE_ERROR,
++						GTK_BUTTONS_OK,
++						"<span weight=\"bold\" size=\"larger\">%s</span>",
++						_("You must select a folder"));
++			gtk_dialog_run (GTK_DIALOG (dialog));
++			gtk_widget_destroy (dialog);
++			return;
++		}
++		char buf[1024];
++		struct stat blah;
++		const char* const conf[] = {"%s/.encfs5", "%s/.encfs6.xml"};
++		unsigned int confs = sizeof conf / sizeof conf[0];
++
++		for (int i = 0; i <= confs; i++) {
++			if (i == confs) {
++				GtkWidget *dialog =
++					gtk_message_dialog_new_with_markup (GTK_WINDOW (m_window),
++							GTK_DIALOG_MODAL,
++							GTK_MESSAGE_ERROR,
++							GTK_BUTTONS_OK,
++							"<span weight=\"bold\" size=\"larger\">%s</span>",
++							_("The selected folder is not an EncFS encrypted folder"));
++				gtk_dialog_run (GTK_DIALOG (dialog));
++				gtk_widget_destroy (dialog);
++				g_free (m_crypt_dir);
++				m_crypt_dir = NULL;
++				return;
++			}
++			snprintf (buf, sizeof (buf), conf[i], m_crypt_dir);
++			if (stat (buf, &blah) == 0 )
++				break;
++		}
++	}
++	if (m_stage == WIZ_PASSWD) {
++		m_mount_dir = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (m_magic));
++		if (m_mount_dir == NULL) {
++			GtkWidget *dialog =
++				gtk_message_dialog_new_with_markup (GTK_WINDOW (m_window),
++						GTK_DIALOG_MODAL,
++						GTK_MESSAGE_ERROR,
++						GTK_BUTTONS_OK,
++						"<span weight=\"bold\" size=\"larger\">%s</span>",
++						_("You must enter a name"));
++			gtk_dialog_run (GTK_DIALOG (dialog));
++			gtk_widget_destroy (dialog);
++			return;
++		}
++	}
++	m_stage++;
++	if (m_stage == WIZ_END) {
++		gtk_widget_set_sensitive (m_button_cancel, FALSE);
++		gtk_button_set_label (GTK_BUTTON (m_button_forward), GTK_STOCK_OK);
++
++		add_crypt_point (m_crypt_dir, m_mount_dir);
++
++		g_free (m_crypt_dir);
++		g_free (m_mount_dir);
++		m_mount_dir = NULL;
++		m_crypt_dir = NULL;
++	}
++	if (m_stage > WIZ_END) {
++		Hide ();
++		Refresh ();
++	} else {
++		UpdateStageUI ();
++	}
++}
++#endif /* HAS_APP_INDICATOR */
++
+ int main (int argc, char *argv[])
+ {
+ 	setlocale (LC_ALL, "");
+@@ -680,15 +1282,32 @@ int main (int argc, char *argv[])
+ 	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it) {
+ 		if (!config_keep_mountpoints) rmdir ((*it).GetMountDir ());
+ 	}
+-
++#ifndef HAS_APP_INDICATOR
+ 	sico = gtk_status_icon_new_from_stock (GTK_STOCK_DIALOG_AUTHENTICATION);
+ 
+ 	g_signal_connect(G_OBJECT(sico), "activate", G_CALLBACK(sico_activated), NULL);
+ 	g_signal_connect(G_OBJECT(sico), "popup-menu", G_CALLBACK(sico_right_button_activated), NULL);
++#else
++	/* Indicator */
++	indicator = app_indicator_new ("cryptkeeper",
++                                   GTK_STOCK_DIALOG_AUTHENTICATION,
++                                   APP_INDICATOR_CATEGORY_APPLICATION_STATUS);
+ 
++	app_indicator_set_status (indicator, APP_INDICATOR_STATUS_ACTIVE);
++	app_indicator_set_attention_icon (indicator, GTK_STOCK_DIALOG_AUTHENTICATION);
++
++	refresh_menu();
++#endif
+ 	create_stash_wizard = new CreateStashWizard ();
++#ifdef HAS_APP_INDICATOR
++	import_stash_wizard = new ImportStashWizardMod ();
++#else
+ 	import_stash_wizard = new ImportStashWizard ();
++#endif
+ 	config_dialog = new ConfigDialog ();
++#ifdef HAS_APP_INDICATOR
++	edit_dialog = new EditDialog ();
++#endif
+ 
+ 	gtk_main ();
+ 	
diff -pruN 0.9.5-5.1/debian/patches/series 0.9.5-5.1ubuntu4/debian/patches/series
--- 0.9.5-5.1/debian/patches/series	2012-05-15 15:09:01.000000000 +0000
+++ 0.9.5-5.1ubuntu4/debian/patches/series	2013-05-13 11:36:36.000000000 +0000
@@ -1,3 +1,4 @@
+add_support_for_appindicator.patch
 fix_cryptkeeper.desktop.patch
 is_mounted_overflow_fix.patch
 binutils-gold.diff
diff -pruN 0.9.5-5.1/debian/rules 0.9.5-5.1ubuntu4/debian/rules
--- 0.9.5-5.1/debian/rules	2011-10-16 11:13:20.000000000 +0000
+++ 0.9.5-5.1ubuntu4/debian/rules	2013-05-13 11:36:36.000000000 +0000
@@ -2,9 +2,11 @@
 
 include /usr/share/cdbs/1/rules/debhelper.mk
 include /usr/share/cdbs/1/class/autotools.mk
+include /usr/share/cdbs/1/rules/buildvars.mk
 
 DEB_INSTALL_MANPAGES_cryptkeeper = debian/cryptkeeper.1
 DEB_MAKE_ENVVARS    := LIBS="-lX11"
+DEB_CONFIGURE_FLAGS_all  += --enable-appindicator=yes
 
 #makebuilddir/cryptkeeper::
 #	cp config.h.in debian/config.h.in-orig
diff -pruN 0.9.5-5.1/.pc/add_support_for_appindicator.patch/configure.ac 0.9.5-5.1ubuntu4/.pc/add_support_for_appindicator.patch/configure.ac
--- 0.9.5-5.1/.pc/add_support_for_appindicator.patch/configure.ac	1970-01-01 00:00:00.000000000 +0000
+++ 0.9.5-5.1ubuntu4/.pc/add_support_for_appindicator.patch/configure.ac	2009-10-18 11:50:39.000000000 +0000
@@ -0,0 +1,30 @@
+# Process this file with autoconf to create configure.
+
+AC_INIT([cryptkeeper], [0.9.5], [tomm@riseup.net])
+AC_PREREQ(2.59)
+AC_CONFIG_HEADERS([config.h])
+AM_INIT_AUTOMAKE([1.9 foreign])
+
+AC_PROG_CC
+AC_GNU_SOURCE
+AC_PROG_CXX
+AC_C_CONST
+AC_STDC_HEADERS
+
+AM_GNU_GETTEXT([external])
+AM_GNU_GETTEXT_VERSION([0.16])
+
+#PKG_CHECK_MODULES(GNOME_KEYRING, gnome-keyring-1, CFLAGS="$CFLAGS -DUSE_GNOME_KEYRING", echo "Gnome Keyring support disabled")
+PKG_CHECK_MODULES(DEP, gtk+-2.0 >= 2.8 gconf-2.0)
+
+#AC_SUBST(DEP_CFLAGS)
+#AC_SUBST(DEP_LIBS)
+
+CFLAGS="$CFLAGS $DEP_CFLAGS $GNOME_KEYRING_CFLAGS"
+CXXFLAGS="$CFLAGS"
+LIBS="$DEP_LIBS $GNOME_KEYRING_LIBS"
+
+#AC_PROG_LIBTOOL
+
+AC_CONFIG_FILES([Makefile src/Makefile po/Makefile.in])
+AC_OUTPUT
diff -pruN 0.9.5-5.1/.pc/add_support_for_appindicator.patch/src/ImportStashWizard.h 0.9.5-5.1ubuntu4/.pc/add_support_for_appindicator.patch/src/ImportStashWizard.h
--- 0.9.5-5.1/.pc/add_support_for_appindicator.patch/src/ImportStashWizard.h	1970-01-01 00:00:00.000000000 +0000
+++ 0.9.5-5.1ubuntu4/.pc/add_support_for_appindicator.patch/src/ImportStashWizard.h	2009-01-22 23:51:02.000000000 +0000
@@ -0,0 +1,35 @@
+#ifndef _IMPORTSTASHWIZARD_H
+#define _IMPORTSTASHWIZARD_H
+
+class ImportStashWizard {
+	public:
+	void Show ();
+	void Hide ();
+	void Restart ();
+	void GoBack ();
+	void GoForward ();
+	ImportStashWizard ();
+	virtual ~ImportStashWizard ();
+	
+	GtkWidget *m_window;
+	private:
+	enum WizardStage {
+		WIZ_START,
+		WIZ_PASSWD,
+		WIZ_END
+	};
+      	int m_stage;
+	GtkWidget *m_vbox;
+	GtkWidget *m_contents;
+	GtkWidget *m_magic;
+	GtkWidget *m_magic2;
+	GtkWidget *m_button_forward;
+	GtkWidget *m_button_cancel;
+
+	char *m_mount_dir;
+	char *m_crypt_dir;
+
+	void UpdateStageUI ();
+};
+
+#endif /* _IMPORTSTASHWIZARD_H */
diff -pruN 0.9.5-5.1/.pc/add_support_for_appindicator.patch/src/main.cpp 0.9.5-5.1ubuntu4/.pc/add_support_for_appindicator.patch/src/main.cpp
--- 0.9.5-5.1/.pc/add_support_for_appindicator.patch/src/main.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 0.9.5-5.1ubuntu4/.pc/add_support_for_appindicator.patch/src/main.cpp	2009-03-06 15:36:03.000000000 +0000
@@ -0,0 +1,696 @@
+/*
+ * This file is part of Cryptkeeper.
+ * Copyright (C) 2007 Tom Morton
+ *
+ * Cryptkeeper is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 3 as
+ * published by the Free Software Foundation.
+ *
+ * Cryptkeeper is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+#include <stdio.h>
+#include <stdlib.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <signal.h>
+#include <gtk/gtk.h>
+#include <string.h>
+#include <vector>
+#include <string>
+#include <assert.h>
+#include <gconf/gconf-client.h>
+#include <mntent.h>
+
+#include "cryptkeeper.h"
+#include "CreateStashWizard.h"
+#include "ImportStashWizard.h"
+#include "PasswordChangeDialog.h"
+#include "PasswordEntryDialog.h"
+#include "ConfigDialog.h"
+#include "encfs_wrapper.h"
+#include "lsof.h"
+
+#if GTK_MINOR_VERSION < 10
+# include "gtkstatusicon.h"
+#endif
+
+
+class CryptPoint {
+	private:
+	char *crypt_dir, *mount_dir;
+	bool isAvailable, isMounted;
+	public:
+	CryptPoint (const char *crypt_dir, const char *mount_dir) {
+		this->crypt_dir = strdup (crypt_dir);
+		this->mount_dir = strdup (mount_dir);
+	}
+	virtual ~CryptPoint () {
+//		free (crypt_dir);
+//		free (mount_dir);
+	}
+	const char *GetMountDir () { return mount_dir; }
+	const char *GetCryptDir () { return crypt_dir; }
+	bool GetIsMounted () { return isMounted; }
+	void SetIsMounted (bool b) { isMounted = b; }
+	bool GetIsAvailable () { return isAvailable; }
+	void SetIsAvailable (bool b) { isAvailable = b; }
+};
+
+static GtkStatusIcon *sico;
+static std::vector<CryptPoint> cryptPoints;
+static CreateStashWizard *create_stash_wizard;
+static ImportStashWizard *import_stash_wizard;
+static ConfigDialog *config_dialog;
+static GConfClient *gconf_client;
+
+char *config_filemanager;
+int config_idletime;
+bool config_keep_mountpoints;
+bool config_allow_other;
+#ifdef USE_GNOME_KEYRING
+bool config_use_keyring;
+#endif /* USE_GNOME_KEYRING */
+
+static bool isdir (const char *filename)
+{
+	struct stat s;
+
+	if (stat (filename, &s) != -1) {
+		if (S_ISDIR (s.st_mode)) return true;
+	}
+	return false;
+}
+
+void add_crypt_point (const char *stash_dir, const char *mount_dir)
+{
+	cryptPoints.push_back (CryptPoint (stash_dir, mount_dir));
+	write_config ();
+}
+
+// Fuse & encfs must be installed, the user must be in group 'fuse'.
+void check_requirements ()
+{
+	FILE *f = fopen ("/dev/fuse", "rw");
+	if (f==NULL) {
+		GtkWidget *dialog = 
+			gtk_message_dialog_new_with_markup (NULL,
+					GTK_DIALOG_MODAL,
+					GTK_MESSAGE_ERROR,
+					GTK_BUTTONS_OK,
+					"<span weight=\"bold\" size=\"larger\">%s</span>\n\n%s",
+					_("Cryptkeeper cannot access fuse and so cannot start"),
+					_("Check that fuse is installed and that you are a member of the fuse group."));
+		gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+		exit (0);
+	}
+	fclose (f);
+
+	struct stat blah;
+	if ((stat ("/usr/bin/encfs", &blah) == -1) &&
+	    (stat ("/usr/local/bin/encfs", &blah) == -1)) {
+		GtkWidget *dialog = 
+			gtk_message_dialog_new_with_markup (NULL,
+					GTK_DIALOG_MODAL,
+					GTK_MESSAGE_ERROR,
+					GTK_BUTTONS_OK,
+					"<span weight=\"bold\" size=\"larger\">%s</span>\n\n%s",
+					_("Cryptkeeper cannot find EncFS"),
+					_("Check that EncFS is installed and try again."));
+		gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+		exit (0);
+	}
+}
+
+void spawn_filemanager (const char *dir)
+{
+	/*char buf[256];
+	snprintf (buf, sizeof (buf), "%s \"%s\" &", config_filemanager, dir);
+	system (buf);*/
+	
+	int pid = fork ();
+	if (pid == 0) {
+		execlp (config_filemanager, config_filemanager, dir, NULL);
+		exit (0);
+	}
+}
+
+// returns true on success
+static bool unmount_cryptpoint (int idx)
+{
+	CryptPoint *cp = &cryptPoints[idx];
+	
+	if (cp->GetIsMounted () == false) return true;
+
+	int result = !encfs_stash_unmount (cp->GetMountDir ());
+	if (!config_keep_mountpoints) rmdir (cp->GetMountDir());
+	return result;
+}
+
+static gboolean timeout_unmount(gpointer data)
+{
+	char *mount_dir = (char*)data;
+	
+	if (0 != encfs_stash_unmount (mount_dir)) {
+		GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+				GTK_DIALOG_MODAL,
+				GTK_MESSAGE_ERROR,
+				GTK_BUTTONS_CANCEL,
+				"<span weight=\"bold\" size=\"larger\">%s</span>",
+				_("Forced unmounting of the encrypted folder was not successful"));
+		gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+	}
+	free(data);
+	return FALSE;
+}
+
+static gboolean timeout_sigkill(gpointer data)
+{
+	char *mount_dir = (char*)data;
+	lsof_result_t ls;
+
+	get_fsusers(&ls, mount_dir);
+	
+	for (__typeof__(ls.fsusers.end()) i = ls.fsusers.begin(); i != ls.fsusers.end(); i++) {
+		kill((*i).pid, SIGKILL);
+	}
+	
+	g_timeout_add (500, timeout_unmount, data);
+	printf("Hello timeout!\n");
+
+	return FALSE;
+}
+
+static void moan_cant_unmount (const char *mount_dir)
+{
+	std::string msg;
+	lsof_result_t ls;
+
+	get_fsusers(&ls, mount_dir);
+
+#define MAX_FSUSERS_TO_LIST	5
+	int max = MAX_FSUSERS_TO_LIST;
+	for (__typeof__(ls.num.end()) i = ls.num.begin(); i != ls.num.end(); i++) {
+		char buf[256];
+		if ((--max <= 0) && (ls.num.size() > MAX_FSUSERS_TO_LIST)) {
+			snprintf(buf, sizeof(buf), _("... %d others ..."), 1 + ls.num.size() - MAX_FSUSERS_TO_LIST);
+			msg += buf;
+			break;
+		}
+		if ((*i).second > 1)
+			snprintf(buf, sizeof(buf), _("%s (%d instances)\n"), (*i).first.c_str(), (*i).second);
+		else	
+			snprintf(buf, sizeof(buf), "%s\n", (*i).first.c_str(), (*i).second);
+		msg += buf;
+	}
+
+	GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+			GTK_DIALOG_MODAL,
+			GTK_MESSAGE_ERROR,
+			GTK_BUTTONS_NONE,
+			"<span weight=\"bold\" size=\"larger\">%s</span>\n\n%s",
+			_("The stash could not be unmounted because it is in use by the following applications:"),
+			msg.c_str()
+			);
+	gtk_dialog_add_button (GTK_DIALOG (dialog), GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL);
+	gtk_dialog_add_button (GTK_DIALOG (dialog), _("Kill them"), GTK_RESPONSE_OK);
+	if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_OK) {
+		// renew list
+		get_fsusers(&ls, mount_dir);
+
+		for (__typeof__(ls.fsusers.end()) i = ls.fsusers.begin(); i != ls.fsusers.end(); i++) {
+			kill((*i).pid, SIGTERM);
+		}
+		// after 5 seconds do SIGKILL, unmount
+		const char *mdir = strdup(mount_dir);
+		g_timeout_add (1000, timeout_sigkill, (void*)mdir);
+	}
+	gtk_widget_destroy (dialog);
+}
+
+static void moan_cant_mount (const char *message)
+{
+	GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+			GTK_DIALOG_MODAL,
+			GTK_MESSAGE_ERROR,
+			GTK_BUTTONS_CANCEL,
+			"<span weight=\"bold\" size=\"larger\">%s</span>",
+			(message ? message : _("The stash could not be mounted. Invalid password?")));
+	gtk_dialog_run (GTK_DIALOG (dialog));
+	gtk_widget_destroy (dialog);
+}
+
+static bool test_crypt_dir_and_moan (const char *crypt_dir)
+{
+	if (isdir (crypt_dir)) return false;
+	else {
+		GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+				GTK_DIALOG_MODAL,
+				GTK_MESSAGE_ERROR,
+				GTK_BUTTONS_CANCEL,
+				"<span weight=\"bold\" size=\"larger\">%s</span>\n\n%s",
+				_("This encrypted folder is currently not available"),
+				_("It may be located on a removable disk, or has been deleted."));
+		gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+		return true;
+	}
+}
+
+static void on_mount_check_item_toggled (GtkCheckMenuItem *mi, int idx)
+{
+	CryptPoint *cp = &cryptPoints[idx];
+	
+	if (test_crypt_dir_and_moan (cp->GetCryptDir ())) return;
+
+	if (cp->GetIsMounted ()) {
+		if (!unmount_cryptpoint (idx)) {
+			moan_cant_unmount (cp->GetMountDir());
+		}
+	} else {
+		for (;;) {
+			PasswordEntryDialog *d = new PasswordEntryDialog();
+			char *password = d->Run();
+			delete d;
+
+			if (password == NULL) return;
+
+			char *message;
+			if (0 == encfs_stash_mount(cp->GetCryptDir(), cp->GetMountDir(), password, config_idletime, 
+					   config_allow_other, &message)) {
+				// success
+				spawn_filemanager (cp->GetMountDir ());
+				free(password);
+				break;
+			} else {
+				if (!config_keep_mountpoints) rmdir (cp->GetMountDir());
+				moan_cant_mount (message);
+				free(password);
+			}
+		}
+	}
+}
+
+static void on_import_stash_clicked (GtkWidget *blah)
+{
+	import_stash_wizard->Show ();
+}
+
+static void on_create_new_stash_clicked (GtkWidget *blah)
+{
+	create_stash_wizard->Show ();
+}
+
+static GtkWidget *stashes_popup_menu;
+
+static bool on_dostuff_menu_destroy ()
+{
+	gtk_widget_destroy (stashes_popup_menu);
+	return FALSE;
+}
+
+gboolean on_click_stash_info (GtkMenuItem *mi, gpointer data)
+{
+	int idx = GPOINTER_TO_INT (data);
+	if (test_crypt_dir_and_moan (cryptPoints[idx].GetCryptDir ())) return FALSE;
+
+	char *msg;
+	encfs_stash_get_info (cryptPoints[idx].GetCryptDir (), &msg);
+	if (msg) {
+		GtkWidget *dialog = gtk_message_dialog_new (NULL,
+				GTK_DIALOG_MODAL,
+				GTK_MESSAGE_INFO,
+				GTK_BUTTONS_CLOSE,
+				_("Crypt directory: %s\nMount directory: %s\n%s"),
+				cryptPoints[idx].GetCryptDir (), 
+				cryptPoints[idx].GetMountDir (),
+				msg);
+		gtk_window_set_title (GTK_WINDOW (dialog), "Information");
+		gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+		free (msg);
+	}
+	return FALSE;
+}
+
+
+gboolean on_click_change_stash_password (GtkMenuItem *mi, gpointer data)
+{
+	int idx = GPOINTER_TO_INT (data);
+
+	if (test_crypt_dir_and_moan (cryptPoints[idx].GetCryptDir ())) return FALSE;
+
+	PasswordChangeDialog *dialog = new PasswordChangeDialog (cryptPoints[idx].GetCryptDir (),
+			cryptPoints[idx].GetMountDir ());
+	dialog->Show ();
+	return FALSE;
+}
+
+gboolean on_click_delete_stash (GtkMenuItem *mi, gpointer data)
+{
+	int idx = GPOINTER_TO_INT (data);
+
+	GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+			GTK_DIALOG_MODAL,
+			GTK_MESSAGE_QUESTION,
+			GTK_BUTTONS_OK_CANCEL,
+			"<span weight=\"bold\" size=\"larger\">%s\n\n%s</span>",
+			_("Are you sure you want to remove the encrypted folder:"),
+			cryptPoints[idx].GetMountDir ());
+	int result = gtk_dialog_run (GTK_DIALOG (dialog));
+	gtk_widget_destroy (dialog);
+	if (result != GTK_RESPONSE_OK) return FALSE;
+	
+	if (!unmount_cryptpoint (idx)) {
+		// fuck. can't unmount
+		moan_cant_unmount (cryptPoints[idx].GetMountDir());
+	} else {
+		GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+				GTK_DIALOG_MODAL,
+				GTK_MESSAGE_WARNING,
+				GTK_BUTTONS_YES_NO,
+				"<span weight=\"bold\" size=\"larger\">%s\n\n%s</span>",
+				_("Do you want to permanently erase the encrypted data:"),
+				cryptPoints[idx].GetCryptDir ());
+		int result = gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+
+		if (result != GTK_RESPONSE_YES) {
+			cryptPoints.erase (cryptPoints.begin () + idx);
+		} else {
+			// recursive delete is tedious to implement ;)
+			char buf[1024];
+			snprintf (buf, sizeof (buf), "rm -rf \"%s\"", cryptPoints[idx].GetCryptDir ());
+			system (buf);
+			cryptPoints.erase (cryptPoints.begin () + idx);
+		}
+		write_config ();
+	}
+	
+	return FALSE;
+}
+
+gboolean on_button_release (GtkWidget *widget, GdkEventButton *event, gpointer data)
+{
+	int item_no = GPOINTER_TO_INT (data);
+
+	if (event->button != 3) return FALSE;
+
+	GtkWidget *menu = gtk_menu_new ();
+
+	GtkWidget *mi = gtk_menu_item_new_with_label (_("Information"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_click_stash_info), GINT_TO_POINTER (item_no));
+	gtk_menu_append (menu,  mi);
+	
+	mi = gtk_menu_item_new_with_label (_("Change password"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_click_change_stash_password), GINT_TO_POINTER (item_no));
+	gtk_menu_append (menu,  mi);
+	
+	mi = gtk_menu_item_new_with_label (_("Delete encrypted folder"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_click_delete_stash), GINT_TO_POINTER (item_no));
+	gtk_menu_append (menu,  mi);
+
+	gtk_widget_show_all (menu);
+
+	gtk_menu_popup (GTK_MENU (menu), NULL, NULL, NULL, widget,
+			0, event->time);
+	g_signal_connect (G_OBJECT (menu), "hide", G_CALLBACK (on_dostuff_menu_destroy), NULL);
+
+	return TRUE;
+}
+
+static const char *about_authors[] = { "Tom Morton <tomm@riseup.net>" };
+/*static const char *about_translators = "Christoph Langner <mail@christoph-langner.de>\n"
+		"Jean-Sébastien Bour <sufflope@sufflope.net>\n"
+		"Phantom X <megaphantomx@bol.com.br>";*/
+
+static void open_config_dialog ()
+{
+	config_dialog->Show ();
+}
+
+static void open_about_dialog ()
+{
+	GtkWidget *dialog = gtk_about_dialog_new ();
+	gtk_about_dialog_set_name (GTK_ABOUT_DIALOG (dialog), "Cryptkeeper "VERSION);
+	gtk_about_dialog_set_authors (GTK_ABOUT_DIALOG (dialog), about_authors);
+	gtk_about_dialog_set_translator_credits (GTK_ABOUT_DIALOG (dialog), _("translator-credits"));
+	gtk_about_dialog_set_license (GTK_ABOUT_DIALOG (dialog),
+		_("This program is free software; you can redistribute it and/or modify it\n"
+		"under the terms of the GNU General Public License version 3, as published\n"
+		"by the Free Software Foundation."));
+	gtk_about_dialog_set_comments (GTK_ABOUT_DIALOG (dialog), "Hasta la victoria siempre!");
+	gtk_dialog_run (GTK_DIALOG (dialog));
+	gtk_widget_destroy (dialog);
+}
+
+static void sico_right_button_activated ()
+{
+	GtkWidget *menu = gtk_menu_new ();
+
+	GtkWidget *mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_PREFERENCES, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_config_dialog), NULL);
+	gtk_menu_append (GTK_MENU (menu), mi);
+
+	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_ABOUT, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_about_dialog), NULL);
+	gtk_menu_append (GTK_MENU (menu), mi);
+
+	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_QUIT, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (gtk_exit), NULL);
+	gtk_menu_append (GTK_MENU (menu), mi);
+
+	gtk_widget_show_all (menu);
+
+	gtk_menu_popup (GTK_MENU (menu), NULL, NULL, gtk_status_icon_position_menu, sico,
+			0, gtk_get_current_event_time ());
+}
+
+static void sico_activated (GtkWidget *data)
+{
+	stashes_popup_menu = gtk_menu_new ();
+
+	GtkWidget *mi = gtk_menu_item_new ();
+	GtkWidget *w = gtk_label_new (NULL);
+	gtk_label_set_markup (GTK_LABEL (w), _("<b>Encrypted folders:</b>"));
+	gtk_container_add (GTK_CONTAINER (mi), w);
+	gtk_widget_set_sensitive (mi, FALSE);
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	int i = 0;
+	std::vector<CryptPoint>::iterator it;
+	// find out which ones are mounted
+	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it, i++) {
+		struct stat s;
+
+		(*it).SetIsMounted (false);
+		(*it).SetIsAvailable (false);
+
+		if (stat ((*it).GetCryptDir (), &s) != -1) {
+			if (S_ISDIR (s.st_mode)) (*it).SetIsAvailable (true);
+		}
+
+		// to get rid of festering mount points
+		if (!config_keep_mountpoints) rmdir ((*it).GetMountDir ());
+
+		if (is_mounted((*it).GetMountDir())) {
+			if (S_ISDIR (s.st_mode)) (*it).SetIsMounted (true);
+		}
+	}
+	
+	i = 0;
+	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it, i++) {
+		mi = gtk_check_menu_item_new ();
+		char buf[256];
+		if ((*it).GetIsAvailable ()) {
+			snprintf (buf, sizeof (buf), "%s", (*it).GetMountDir ());
+		} else {
+			snprintf (buf, sizeof (buf), "<span foreground=\"grey\">%s</span>", (*it).GetMountDir ());
+		}
+		GtkWidget *label = gtk_label_new (NULL);
+		gtk_label_set_markup (GTK_LABEL (label), buf);
+		gtk_container_add (GTK_CONTAINER (mi), label);
+		gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (mi), (*it).GetIsMounted ());
+		//gtk_widget_set_sensitive (mi, (*it).GetIsAvailable ());
+		gtk_menu_append (stashes_popup_menu, mi);
+		g_signal_connect (G_OBJECT (mi), "toggled", G_CALLBACK (on_mount_check_item_toggled), GINT_TO_POINTER (i));
+		g_signal_connect (G_OBJECT (mi), "button-release-event", G_CALLBACK (on_button_release), GINT_TO_POINTER (i));
+	}
+
+	mi = gtk_separator_menu_item_new ();
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	mi = gtk_menu_item_new_with_label (_("Import EncFS folder"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_import_stash_clicked), NULL);
+	gtk_menu_append (stashes_popup_menu, mi);
+	
+	mi = gtk_menu_item_new_with_label (_("New encrypted folder"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_create_new_stash_clicked), NULL);
+	gtk_menu_append (stashes_popup_menu, mi);
+	
+	gtk_widget_show_all (stashes_popup_menu);
+
+	gtk_menu_popup (GTK_MENU (stashes_popup_menu), NULL, NULL, gtk_status_icon_position_menu, sico,
+			0, gtk_get_current_event_time ());
+}
+
+#define CONF_DIR "/apps/cryptkeeper"
+#define CONF_PATH_FILEMANAGER "/apps/cryptkeeper/filemanager"
+#define CONF_IDLE_TIMEOUT "/apps/cryptkeeper/idletimeout"
+#define CONF_KEEP_MOUNTPOINTS "/apps/cryptkeeper/keep_mountpoints"
+#define CONF_ALLOW_OTHER "/apps/cryptkeeper/allow_other"
+#define CONF_STASHES "/apps/cryptkeeper/stashes"
+char *config_loc;
+
+void write_config ()
+{
+	char buf[1024];
+	
+	gconf_client_set_bool(gconf_client, CONF_ALLOW_OTHER, config_allow_other, NULL);
+	gconf_client_set_bool(gconf_client, CONF_KEEP_MOUNTPOINTS, config_keep_mountpoints, NULL);
+	gconf_client_set_int (gconf_client, CONF_IDLE_TIMEOUT, config_idletime, NULL);
+	gconf_client_set_string (gconf_client, CONF_PATH_FILEMANAGER, config_filemanager, NULL);
+	
+	std::string crud;
+	std::vector<CryptPoint>::iterator it;
+	// find out which ones are mounted
+	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it) {
+		snprintf (buf, sizeof (buf), "%s\n%s\n", (*it).GetCryptDir (), (*it).GetMountDir ());
+		crud += buf;
+	}
+	gconf_client_set_string (gconf_client, CONF_STASHES, crud.c_str (), NULL);
+}
+
+void read_config ()
+{
+	char buf[1024];
+	
+	config_allow_other = gconf_client_get_bool(gconf_client, CONF_ALLOW_OTHER, NULL);
+	config_keep_mountpoints = gconf_client_get_bool(gconf_client, CONF_KEEP_MOUNTPOINTS, NULL);
+	config_idletime = gconf_client_get_int (gconf_client, CONF_IDLE_TIMEOUT, NULL);
+	config_filemanager = gconf_client_get_string (gconf_client, CONF_PATH_FILEMANAGER, NULL);
+	if (config_filemanager == NULL) {
+		config_filemanager = strdup (DEFAULT_FILEMANAGER);
+	} else {
+		char *s = config_filemanager;
+		config_filemanager = strdup (s);
+		g_free (s);
+	}
+	
+	char *stash_conf = gconf_client_get_string (gconf_client, CONF_STASHES, NULL);
+	cryptPoints.clear ();
+
+	if (stash_conf) {
+		char *pos = stash_conf;
+		while (*pos != '\0') {
+			char *second = strchr (pos, '\n');
+			*(second++) = '\0';
+			char *next = strchr (second, '\n');
+			if (*next) *(next++) = '\0';
+			cryptPoints.push_back (CryptPoint (pos, second));
+			pos = next;
+		}
+		g_free (stash_conf);
+	} else {
+		// load legacy config
+		snprintf (buf, sizeof (buf), "%s/.config/cryptkeeper/stashes", getenv ("HOME"));
+		FILE *f = fopen (buf, "r");
+
+		int line_no = 0;
+		char *crypt_dir, *mount_dir, *pos;
+		// stashes is plain text, # lines are comments, others should be in form:
+		// "crypt directory" "mount directory"
+		if (f != NULL) {
+			while (fgets (buf, sizeof (buf), f)) {
+				line_no++;
+				pos = NULL;
+	
+				if (buf[0] == '#') continue;
+	
+				if (buf[0] == '\"') {
+					crypt_dir = &buf[1];
+					pos = strchr (crypt_dir, '\"');
+					if (pos == NULL) goto bad;
+
+					pos[0] = '\0';
+					pos++;
+
+					pos = strchr (pos, '\"');
+					if (pos == NULL) goto bad;
+					pos++;
+					mount_dir = pos;
+					pos = strchr (pos, '\"');
+					if (pos == NULL) goto bad;
+
+					*pos = '\0';
+					cryptPoints.push_back (CryptPoint (crypt_dir, mount_dir));
+					continue;
+				}
+	bad:
+				fprintf (stderr, "Error parsing ~/.config/cryptkeeper/stashes at line %d\n", line_no);
+			}
+		}
+	}
+}
+
+static void on_sigchld (int blah)
+{
+	wait (NULL);
+}
+
+// so that other crud can change the stash config and we stay in sync
+// (for example, some hypothetical future nautilus plugin that can
+// create stashes....)
+static void on_change_conf_stashes (GConfClient *client, guint cnxn_id, GConfEntry *entry, gpointer user_data)
+{
+	read_config ();
+}
+
+int main (int argc, char *argv[])
+{
+	setlocale (LC_ALL, "");
+	bindtextdomain (PACKAGE, LOCALEDIR);
+	textdomain (PACKAGE);
+
+	signal (SIGCHLD, on_sigchld);
+	
+	gtk_init (&argc, &argv);
+	gconf_client = gconf_client_get_default ();
+
+	gconf_client_add_dir (gconf_client, CONF_DIR, GCONF_CLIENT_PRELOAD_NONE, NULL);
+	gconf_client_notify_add (gconf_client, CONF_STASHES, on_change_conf_stashes, NULL, NULL, NULL);
+
+	read_config ();
+
+	check_requirements ();
+
+	// festering mount points
+	std::vector<CryptPoint>::iterator it;
+	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it) {
+		if (!config_keep_mountpoints) rmdir ((*it).GetMountDir ());
+	}
+
+	sico = gtk_status_icon_new_from_stock (GTK_STOCK_DIALOG_AUTHENTICATION);
+
+	g_signal_connect(G_OBJECT(sico), "activate", G_CALLBACK(sico_activated), NULL);
+	g_signal_connect(G_OBJECT(sico), "popup-menu", G_CALLBACK(sico_right_button_activated), NULL);
+
+	create_stash_wizard = new CreateStashWizard ();
+	import_stash_wizard = new ImportStashWizard ();
+	config_dialog = new ConfigDialog ();
+
+	gtk_main ();
+	
+	return 0;
+}
diff -pruN 0.9.5-5.1/.pc/applied-patches 0.9.5-5.1ubuntu4/.pc/applied-patches
--- 0.9.5-5.1/.pc/applied-patches	2015-04-03 12:36:26.987991160 +0000
+++ 0.9.5-5.1ubuntu4/.pc/applied-patches	2015-04-03 12:36:27.215997349 +0000
@@ -1,3 +1,4 @@
+add_support_for_appindicator.patch
 fix_cryptkeeper.desktop.patch
 is_mounted_overflow_fix.patch
 binutils-gold.diff
diff -pruN 0.9.5-5.1/src/ImportStashWizard.h 0.9.5-5.1ubuntu4/src/ImportStashWizard.h
--- 0.9.5-5.1/src/ImportStashWizard.h	2009-01-22 23:51:02.000000000 +0000
+++ 0.9.5-5.1ubuntu4/src/ImportStashWizard.h	2015-04-03 12:36:27.000000000 +0000
@@ -7,12 +7,12 @@ class ImportStashWizard {
 	void Hide ();
 	void Restart ();
 	void GoBack ();
-	void GoForward ();
+	virtual void GoForward ();
 	ImportStashWizard ();
 	virtual ~ImportStashWizard ();
 	
 	GtkWidget *m_window;
-	private:
+	protected:
 	enum WizardStage {
 		WIZ_START,
 		WIZ_PASSWD,
diff -pruN 0.9.5-5.1/src/main.cpp 0.9.5-5.1ubuntu4/src/main.cpp
--- 0.9.5-5.1/src/main.cpp	2009-03-06 15:36:03.000000000 +0000
+++ 0.9.5-5.1ubuntu4/src/main.cpp	2015-04-03 12:36:27.000000000 +0000
@@ -43,6 +43,9 @@
 # include "gtkstatusicon.h"
 #endif
 
+#ifdef HAS_APP_INDICATOR
+#include <libappindicator/app-indicator.h>
+#endif
 
 class CryptPoint {
 	private:
@@ -65,13 +68,58 @@ class CryptPoint {
 	void SetIsAvailable (bool b) { isAvailable = b; }
 };
 
+#ifdef HAS_APP_INDICATOR
+class EditDialog {
+  public:
+  void Initialise ();
+  void Show ();
+  void Hide ();
+  EditDialog ();
+  virtual ~EditDialog ();
+
+  GtkWidget *m_window;
+    GtkWidget *m_view;
+    GtkWidget *m_vbox;
+    GtkWidget *m_hbox;
+    GtkWidget *m_buttonbox;
+    GtkWidget *m_sidebuttonbox;
+    GtkWidget *m_button_information;
+    GtkWidget *m_button_password;
+    GtkWidget *m_button_cancel;
+    GtkWidget *m_button_delete;
+    GtkWidget *m_label;
+    GtkTreeSelection *m_selection;
+    GtkTreeModel *m_model;
+    GtkListStore *m_store;
+  private:
+};
+
+class ImportStashWizardMod : public ImportStashWizard {
+  public:
+  void Refresh ();
+  void GoForward ();
+};
+
+static void update_view (GtkWidget *m_view);
+
+static EditDialog *edit_dialog;
+#endif
 static GtkStatusIcon *sico;
 static std::vector<CryptPoint> cryptPoints;
 static CreateStashWizard *create_stash_wizard;
+#ifdef HAS_APP_INDICATOR
+static ImportStashWizardMod *import_stash_wizard;
+#else
 static ImportStashWizard *import_stash_wizard;
+#endif
 static ConfigDialog *config_dialog;
 static GConfClient *gconf_client;
 
+#ifdef HAS_APP_INDICATOR
+static AppIndicator *indicator;
+static void refresh_menu (void);
+#endif
+
 char *config_filemanager;
 int config_idletime;
 bool config_keep_mountpoints;
@@ -300,6 +348,9 @@ static void on_mount_check_item_toggled
 			}
 		}
 	}
+#ifdef HAS_APP_INDICATOR
+	refresh_menu();
+#endif
 }
 
 static void on_import_stash_clicked (GtkWidget *blah)
@@ -312,7 +363,7 @@ static void on_create_new_stash_clicked
 	create_stash_wizard->Show ();
 }
 
-static GtkWidget *stashes_popup_menu;
+static GtkWidget *stashes_popup_menu = NULL;
 
 static bool on_dostuff_menu_destroy ()
 {
@@ -344,6 +395,30 @@ gboolean on_click_stash_info (GtkMenuIte
 	return FALSE;
 }
 
+#ifdef HAS_APP_INDICATOR
+gboolean get_stash_info (int idx)
+{
+	if (test_crypt_dir_and_moan (cryptPoints[idx].GetCryptDir ())) return FALSE;
+
+	char *msg;
+	encfs_stash_get_info (cryptPoints[idx].GetCryptDir (), &msg);
+	if (msg) {
+		GtkWidget *dialog = gtk_message_dialog_new (NULL,
+				GTK_DIALOG_MODAL,
+				GTK_MESSAGE_INFO,
+				GTK_BUTTONS_CLOSE,
+				_("Crypt directory: %s\nMount directory: %s\n%s"),
+				cryptPoints[idx].GetCryptDir (),
+				cryptPoints[idx].GetMountDir (),
+				msg);
+		gtk_window_set_title (GTK_WINDOW (dialog), "Information");
+		gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+		free (msg);
+	}
+	return FALSE;
+}
+#endif
 
 gboolean on_click_change_stash_password (GtkMenuItem *mi, gpointer data)
 {
@@ -401,6 +476,60 @@ gboolean on_click_delete_stash (GtkMenuI
 	return FALSE;
 }
 
+#ifdef HAS_APP_INDICATOR
+gboolean change_stash_password (int idx)
+{
+	if (test_crypt_dir_and_moan (cryptPoints[idx].GetCryptDir ())) return FALSE;
+
+	PasswordChangeDialog *dialog = new PasswordChangeDialog (cryptPoints[idx].GetCryptDir (),
+			cryptPoints[idx].GetMountDir ());
+	dialog->Show ();
+	return TRUE;
+}
+
+gboolean delete_stash (int idx)
+{
+	GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+			GTK_DIALOG_MODAL,
+			GTK_MESSAGE_QUESTION,
+			GTK_BUTTONS_OK_CANCEL,
+			"<span weight=\"bold\" size=\"larger\">%s\n\n%s</span>",
+			_("Are you sure you want to remove the encrypted folder:"),
+			cryptPoints[idx].GetMountDir ());
+	int result = gtk_dialog_run (GTK_DIALOG (dialog));
+	gtk_widget_destroy (dialog);
+	if (result != GTK_RESPONSE_OK) return FALSE;
+
+	if (!unmount_cryptpoint (idx)) {
+		// fuck. can't unmount
+		moan_cant_unmount (cryptPoints[idx].GetMountDir());
+	} else {
+		GtkWidget *dialog = gtk_message_dialog_new_with_markup (NULL,
+				GTK_DIALOG_MODAL,
+				GTK_MESSAGE_WARNING,
+				GTK_BUTTONS_YES_NO,
+				"<span weight=\"bold\" size=\"larger\">%s\n\n%s</span>",
+				_("Do you want to permanently erase the encrypted data:"),
+				cryptPoints[idx].GetCryptDir ());
+		int result = gtk_dialog_run (GTK_DIALOG (dialog));
+		gtk_widget_destroy (dialog);
+
+		if (result != GTK_RESPONSE_YES) {
+			cryptPoints.erase (cryptPoints.begin () + idx);
+		} else {
+			// recursive delete is tedious to implement ;)
+			char buf[1024];
+			snprintf (buf, sizeof (buf), "rm -rf \"%s\"", cryptPoints[idx].GetCryptDir ());
+			system (buf);
+			cryptPoints.erase (cryptPoints.begin () + idx);
+		}
+		write_config ();
+	}
+
+	return TRUE;
+}
+#endif
+
 gboolean on_button_release (GtkWidget *widget, GdkEventButton *event, gpointer data)
 {
 	int item_no = GPOINTER_TO_INT (data);
@@ -440,6 +569,15 @@ static void open_config_dialog ()
 	config_dialog->Show ();
 }
 
+#ifdef HAS_APP_INDICATOR
+static void open_edit_dialog ()
+{
+	edit_dialog->Hide ();
+	edit_dialog->Initialise ();
+	edit_dialog->Show ();
+}
+#endif
+
 static void open_about_dialog ()
 {
 	GtkWidget *dialog = gtk_about_dialog_new ();
@@ -455,6 +593,7 @@ static void open_about_dialog ()
 	gtk_widget_destroy (dialog);
 }
 
+#ifndef HAS_APP_INDICATOR
 static void sico_right_button_activated ()
 {
 	GtkWidget *menu = gtk_menu_new ();
@@ -476,7 +615,100 @@ static void sico_right_button_activated
 	gtk_menu_popup (GTK_MENU (menu), NULL, NULL, gtk_status_icon_position_menu, sico,
 			0, gtk_get_current_event_time ());
 }
+#endif
+
+#ifdef HAS_APP_INDICATOR
+static void refresh_menu (void)
+{
+	if (stashes_popup_menu)
+		gtk_widget_destroy (stashes_popup_menu);
+
+	stashes_popup_menu = gtk_menu_new ();
+
+	GtkWidget *mi = gtk_menu_item_new ();
+	GtkWidget *w = gtk_label_new (NULL);
+	gtk_label_set_markup (GTK_LABEL (w), _("<b>Encrypted folders:</b>"));
+	gtk_container_add (GTK_CONTAINER (mi), w);
+	gtk_widget_set_sensitive (mi, FALSE);
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	int i = 0;
+	std::vector<CryptPoint>::iterator it;
+	// find out which ones are mounted
+	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it, i++) {
+		struct stat s;
+
+		(*it).SetIsMounted (false);
+		(*it).SetIsAvailable (false);
+
+		if (stat ((*it).GetCryptDir (), &s) != -1) {
+			if (S_ISDIR (s.st_mode)) (*it).SetIsAvailable (true);
+		}
+
+		// to get rid of festering mount points
+		if (!config_keep_mountpoints) rmdir ((*it).GetMountDir ());
+
+		if (is_mounted((*it).GetMountDir())) {
+			if (S_ISDIR (s.st_mode)) (*it).SetIsMounted (true);
+		}
+	}
+
+	i = 0;
+	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it, i++) {
+		mi = gtk_check_menu_item_new ();
+		char buf[256];
+		if ((*it).GetIsAvailable ()) {
+			snprintf (buf, sizeof (buf), "%s", (*it).GetMountDir ());
+		} else {
+			snprintf (buf, sizeof (buf), "<span foreground=\"grey\">%s</span>", (*it).GetMountDir ());
+		}
+		GtkWidget *label = gtk_label_new (NULL);
+		gtk_label_set_markup (GTK_LABEL (label), buf);
+		gtk_container_add (GTK_CONTAINER (mi), label);
+		gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (mi), (*it).GetIsMounted ());
+		//gtk_widget_set_sensitive (mi, (*it).GetIsAvailable ());
+		gtk_menu_append (stashes_popup_menu, mi);
+		g_signal_connect (G_OBJECT (mi), "toggled", G_CALLBACK (on_mount_check_item_toggled), GINT_TO_POINTER (i));
+	}
+
+	mi = gtk_separator_menu_item_new ();
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	mi = gtk_menu_item_new_with_label (_("Import EncFS folder"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_import_stash_clicked), NULL);
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	mi = gtk_menu_item_new_with_label (_("New encrypted folder"));
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (on_create_new_stash_clicked), NULL);
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	mi = gtk_separator_menu_item_new ();
+	gtk_menu_append (stashes_popup_menu, mi);
+
+	/* previous right click code */
+	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_EDIT, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_edit_dialog), NULL);
+	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
+
+	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_PREFERENCES, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_config_dialog), NULL);
+	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
+
+	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_ABOUT, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (open_about_dialog), NULL);
+	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
+
+	mi = gtk_image_menu_item_new_from_stock (GTK_STOCK_QUIT, NULL);
+	g_signal_connect (G_OBJECT (mi), "activate", G_CALLBACK (gtk_exit), NULL);
+	gtk_menu_append (GTK_MENU (stashes_popup_menu), mi);
+
+	gtk_widget_show_all (stashes_popup_menu);
+
+	app_indicator_set_menu (indicator, GTK_MENU (stashes_popup_menu));
+}
+#endif
 
+#ifndef HAS_APP_INDICATOR
 static void sico_activated (GtkWidget *data)
 {
 	stashes_popup_menu = gtk_menu_new ();
@@ -544,6 +776,7 @@ static void sico_activated (GtkWidget *d
 	gtk_menu_popup (GTK_MENU (stashes_popup_menu), NULL, NULL, gtk_status_icon_position_menu, sico,
 			0, gtk_get_current_event_time ());
 }
+#endif
 
 #define CONF_DIR "/apps/cryptkeeper"
 #define CONF_PATH_FILEMANAGER "/apps/cryptkeeper/filemanager"
@@ -657,6 +890,375 @@ static void on_change_conf_stashes (GCon
 	read_config ();
 }
 
+#ifdef HAS_APP_INDICATOR
+enum
+{
+  COL_NAME = 0,
+  COL_AGE,
+  NUM_COLS
+} ;
+
+#define UI_SPACING 0
+
+static gboolean on_edit_window_close (GtkWidget *window, GdkEvent *event, EditDialog *dialog)
+{
+  dialog->Hide ();
+  return TRUE;
+}
+
+static void on_edit_cancel_clicked (GtkButton *button, EditDialog *dialog)
+{
+  dialog->Hide ();
+}
+
+static gboolean is_any_row_selected (GtkTreeView *treeview)
+{
+  GtkTreeSelection *selection;
+  GtkTreeModel     *model;
+  GtkTreeIter       iter;
+
+  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(treeview));
+  return (gtk_tree_selection_get_selected(selection, &model, &iter));
+}
+
+static void on_information_clicked (GtkButton *button, GtkWidget *widget)
+{
+  GtkTreeSelection *selection;
+  GtkTreeModel     *model;
+  GtkTreeIter       iter;
+  GtkTreePath *path;
+  int index;
+  /* This will only work in single or browse selection mode! */
+
+  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(widget));
+  if (gtk_tree_selection_get_selected(selection, &model, &iter))
+  {
+    path = gtk_tree_model_get_path (model, &iter);
+    index = (int) gtk_tree_path_get_indices (path)[0];
+    /* Show the dialog */
+    get_stash_info (index);
+  }
+}
+
+static void on_delete_clicked (GtkButton *button, GtkWidget *widget)
+{
+  GtkTreeSelection *selection;
+  GtkTreeModel     *model;
+  GtkTreeIter       iter;
+  GtkTreePath *path;
+  int index;
+  /* This will only work in single or browse selection mode! */
+
+  selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(widget));
+  if (gtk_tree_selection_get_selected (selection, &model, &iter))
+  {
+    path = gtk_tree_model_get_path (model, &iter);
+    index = (int) gtk_tree_path_get_indices (path)[0];
+
+    /* delete_stash and remove from the tree */
+    if (delete_stash (index))
+    {
+      /* Remove the dir at index */
+      gtk_list_store_remove (GTK_LIST_STORE(model), &iter);
+      gtk_widget_set_sensitive (gtk_widget_get_parent((GtkWidget *) button), FALSE);
+
+      /* Refresh the indicator */
+      refresh_menu ();
+
+      /* Update the Treeview */
+      update_view (widget);
+    }
+  }
+}
+
+static void on_change_password_clicked (GtkButton *button, GtkWidget *widget)
+{
+  GtkTreeSelection *selection;
+  GtkTreeModel     *model;
+  GtkTreeIter       iter;
+  GtkTreePath *path;
+  int index;
+  /* This will only work in single or browse selection mode! */
+
+  selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(widget));
+  if (gtk_tree_selection_get_selected(selection, &model, &iter))
+  {
+    path = gtk_tree_model_get_path (model, &iter);
+    index = (int) gtk_tree_path_get_indices (path)[0];
+
+    change_stash_password (index);
+  }
+}
+
+/* Make the buttonbox sensitive when the cursor is on a row */
+static void on_row_selected (GtkWidget *widget, EditDialog *dialog)
+{
+  if (is_any_row_selected((GtkTreeView *) dialog->m_view))
+  {
+    gtk_widget_set_sensitive (dialog->m_sidebuttonbox, TRUE);
+  }
+}
+
+static void
+add_row (GtkListStore * store, const gchar *dir)
+{
+  GtkTreeIter    iter;
+  /* Append a row and fill in some data */
+  gtk_list_store_append (store, &iter);
+  gtk_list_store_set (store, &iter,
+                      COL_NAME, dir,
+                      -1);
+}
+
+
+static GtkTreeModel *
+create_and_fill_model (void)
+{
+  GtkListStore  *store;
+
+  store = gtk_list_store_new (1, G_TYPE_STRING, G_TYPE_UINT);
+
+  return GTK_TREE_MODEL (store);
+}
+
+static GtkWidget *
+create_view_and_model (void)
+{
+  GtkCellRenderer     *renderer;
+  GtkTreeModel        *model;
+  GtkWidget           *view;
+
+  view = gtk_tree_view_new ();
+
+  /* --- Column #1 --- */
+  renderer = gtk_cell_renderer_text_new ();
+  gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW (view),
+                                               -1,
+                                               "Name",
+                                               renderer,
+                                               "text", COL_NAME,
+                                               NULL);
+  gtk_tree_view_set_headers_visible (GTK_TREE_VIEW (view), FALSE);
+
+  model = create_and_fill_model ();
+
+  gtk_tree_view_set_model (GTK_TREE_VIEW (view), model);
+
+  /* The tree view has acquired its own reference to the
+   *  model, so we can drop ours. This way the model will
+   *  be freed automatically when the tree view is destroyed */
+  g_object_unref (model);
+
+  return view;
+}
+
+EditDialog::~EditDialog ()
+{
+  gtk_widget_destroy (m_window);
+}
+
+void EditDialog::Show ()
+{
+  gtk_widget_show_all (m_window);
+}
+
+void EditDialog::Hide ()
+{
+  gtk_widget_destroy (m_window);
+}
+
+static void update_treemodel (GtkTreeModel *model) {
+  gtk_list_store_clear (GTK_LIST_STORE (model));
+
+  std::vector<CryptPoint>::iterator it;
+    for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it) {
+      add_row (GTK_LIST_STORE(model), (*it).GetMountDir() );
+    }
+}
+
+static void update_view (GtkWidget *m_view)
+{
+  /* Refresh view */
+  GtkTreeModel *model;
+  GtkTreePath *path;
+  GtkTreeSelection *selection;
+
+  if (m_view)
+    {
+    model = gtk_tree_view_get_model (GTK_TREE_VIEW (m_view));
+
+    /* Clear and update the model */
+    update_treemodel (model);
+
+	/* Select the first row */
+	selection = gtk_tree_view_get_selection (GTK_TREE_VIEW(m_view));
+    path = gtk_tree_path_new_first();
+    gtk_tree_selection_select_path(selection, path);
+    gtk_tree_path_free (path);
+    }
+}
+
+void EditDialog::Initialise ()
+{
+  m_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
+  gtk_window_set_position (GTK_WINDOW(m_window), GTK_WIN_POS_CENTER_ALWAYS);
+  gtk_container_set_border_width (GTK_CONTAINER (m_window), 12);
+  g_signal_connect(G_OBJECT(m_window), "delete-event", G_CALLBACK(on_edit_window_close), this);
+
+    /* main_m_vbox */
+  m_vbox = gtk_vbox_new (FALSE, 12); //UI_SPACING);
+  gtk_container_set_border_width (GTK_CONTAINER (m_vbox), 0);
+  //gtk_container_add(GTK_CONTAINER(main_alignment), m_vbox);
+  gtk_container_add(GTK_CONTAINER(m_window), m_vbox);
+
+      /* m_label */
+  m_label = gtk_label_new (_("Select one of the following encrypted folders:"));
+      /* horizontal : left, vertical : centered */
+  gtk_misc_set_alignment (GTK_MISC(m_label), 0.0f, 0.5f);
+  gtk_misc_set_padding (GTK_MISC(m_label), 12, 0);
+  gtk_box_pack_start (GTK_BOX (m_vbox), m_label, FALSE, FALSE, UI_SPACING);
+
+    /* m_hbox */
+  m_hbox = gtk_hbox_new (FALSE, UI_SPACING);
+  gtk_container_set_border_width (GTK_CONTAINER (m_hbox), 0);
+  //gtk_misc_set_padding (GTK_MISC(m_hbox), 12, 0);
+  gtk_box_pack_start (GTK_BOX (m_vbox), m_hbox, FALSE, FALSE, UI_SPACING);
+      /* treeview */
+  m_model = NULL;
+  m_view = NULL;
+
+  m_view = create_view_and_model ();
+
+  /* Only one selection */
+  m_selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(m_view));
+  gtk_tree_selection_set_mode(m_selection, GTK_SELECTION_SINGLE);
+  //gtk_tree_selection_select_iter(m_selection, 0);
+
+  gtk_box_pack_start (GTK_BOX (m_hbox), m_view, TRUE, TRUE, UI_SPACING);
+
+      /* m_sidebuttonbox */
+  m_sidebuttonbox = gtk_vbutton_box_new ();
+  m_button_information = gtk_button_new_from_stock (GTK_STOCK_INFO);
+  g_signal_connect (G_OBJECT (m_button_information), "clicked", G_CALLBACK (on_information_clicked), m_view);
+  gtk_widget_set_sensitive (m_sidebuttonbox, FALSE);
+
+  m_button_password = gtk_button_new_with_label(_("Change Password"));
+  m_button_delete = gtk_button_new_from_stock (GTK_STOCK_DELETE);
+
+  gtk_box_pack_start (GTK_BOX (m_sidebuttonbox), m_button_information, FALSE, FALSE, UI_SPACING);
+  gtk_box_pack_start (GTK_BOX (m_sidebuttonbox), m_button_password, FALSE, FALSE, UI_SPACING);
+  gtk_box_pack_start (GTK_BOX (m_sidebuttonbox), m_button_delete, FALSE, FALSE, UI_SPACING);
+  gtk_button_box_set_layout ((GtkButtonBox *) m_sidebuttonbox, GTK_BUTTONBOX_START);
+  gtk_box_pack_start (GTK_BOX (m_hbox),m_sidebuttonbox, FALSE, FALSE, UI_SPACING);
+
+    /* hButtonBox */
+  m_buttonbox = gtk_hbutton_box_new ();
+  gtk_container_set_border_width (GTK_CONTAINER (m_hbox), 0);
+  m_button_cancel = gtk_button_new_from_stock (GTK_STOCK_CANCEL);
+  g_signal_connect (G_OBJECT (m_button_cancel), "clicked", G_CALLBACK (on_edit_cancel_clicked), this);
+  g_signal_connect (G_OBJECT (m_button_delete), "clicked", G_CALLBACK (on_delete_clicked), m_view);
+  g_signal_connect (G_OBJECT (m_button_password), "clicked", G_CALLBACK (on_change_password_clicked), m_view);
+
+  gtk_box_pack_end (GTK_BOX (m_buttonbox), m_button_cancel, FALSE, FALSE, UI_SPACING);
+  gtk_button_box_set_layout ((GtkButtonBox *) m_buttonbox, GTK_BUTTONBOX_END);
+  gtk_box_pack_end (GTK_BOX (m_vbox), m_buttonbox, FALSE, FALSE, UI_SPACING);
+
+
+  g_signal_connect (G_OBJECT (m_view), "cursor-changed", G_CALLBACK (on_row_selected), this);
+
+  gtk_window_set_resizable((GtkWindow *) m_window, FALSE);
+
+
+  update_view (m_view);
+}
+
+EditDialog::EditDialog ()
+{
+  Initialise ();
+}
+
+void ImportStashWizardMod::Refresh ()
+{
+	refresh_menu ();
+}
+
+void ImportStashWizardMod::GoForward ()
+{
+	if (m_stage == WIZ_START) {
+		m_crypt_dir = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (m_magic));
+		if (m_crypt_dir == NULL) {
+			GtkWidget *dialog = 
+				gtk_message_dialog_new_with_markup (GTK_WINDOW (m_window),
+						GTK_DIALOG_MODAL,
+						GTK_MESSAGE_ERROR,
+						GTK_BUTTONS_OK,
+						"<span weight=\"bold\" size=\"larger\">%s</span>",
+						_("You must select a folder"));
+			gtk_dialog_run (GTK_DIALOG (dialog));
+			gtk_widget_destroy (dialog);
+			return;
+		}
+		char buf[1024];
+		struct stat blah;
+		const char* const conf[] = {"%s/.encfs5", "%s/.encfs6.xml"};
+		unsigned int confs = sizeof conf / sizeof conf[0];
+
+		for (int i = 0; i <= confs; i++) {
+			if (i == confs) {
+				GtkWidget *dialog =
+					gtk_message_dialog_new_with_markup (GTK_WINDOW (m_window),
+							GTK_DIALOG_MODAL,
+							GTK_MESSAGE_ERROR,
+							GTK_BUTTONS_OK,
+							"<span weight=\"bold\" size=\"larger\">%s</span>",
+							_("The selected folder is not an EncFS encrypted folder"));
+				gtk_dialog_run (GTK_DIALOG (dialog));
+				gtk_widget_destroy (dialog);
+				g_free (m_crypt_dir);
+				m_crypt_dir = NULL;
+				return;
+			}
+			snprintf (buf, sizeof (buf), conf[i], m_crypt_dir);
+			if (stat (buf, &blah) == 0 )
+				break;
+		}
+	}
+	if (m_stage == WIZ_PASSWD) {
+		m_mount_dir = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (m_magic));
+		if (m_mount_dir == NULL) {
+			GtkWidget *dialog =
+				gtk_message_dialog_new_with_markup (GTK_WINDOW (m_window),
+						GTK_DIALOG_MODAL,
+						GTK_MESSAGE_ERROR,
+						GTK_BUTTONS_OK,
+						"<span weight=\"bold\" size=\"larger\">%s</span>",
+						_("You must enter a name"));
+			gtk_dialog_run (GTK_DIALOG (dialog));
+			gtk_widget_destroy (dialog);
+			return;
+		}
+	}
+	m_stage++;
+	if (m_stage == WIZ_END) {
+		gtk_widget_set_sensitive (m_button_cancel, FALSE);
+		gtk_button_set_label (GTK_BUTTON (m_button_forward), GTK_STOCK_OK);
+
+		add_crypt_point (m_crypt_dir, m_mount_dir);
+
+		g_free (m_crypt_dir);
+		g_free (m_mount_dir);
+		m_mount_dir = NULL;
+		m_crypt_dir = NULL;
+	}
+	if (m_stage > WIZ_END) {
+		Hide ();
+		Refresh ();
+	} else {
+		UpdateStageUI ();
+	}
+}
+#endif /* HAS_APP_INDICATOR */
+
 int main (int argc, char *argv[])
 {
 	setlocale (LC_ALL, "");
@@ -680,15 +1282,32 @@ int main (int argc, char *argv[])
 	for (it = cryptPoints.begin (); it != cryptPoints.end (); ++it) {
 		if (!config_keep_mountpoints) rmdir ((*it).GetMountDir ());
 	}
-
+#ifndef HAS_APP_INDICATOR
 	sico = gtk_status_icon_new_from_stock (GTK_STOCK_DIALOG_AUTHENTICATION);
 
 	g_signal_connect(G_OBJECT(sico), "activate", G_CALLBACK(sico_activated), NULL);
 	g_signal_connect(G_OBJECT(sico), "popup-menu", G_CALLBACK(sico_right_button_activated), NULL);
+#else
+	/* Indicator */
+	indicator = app_indicator_new ("cryptkeeper",
+                                   GTK_STOCK_DIALOG_AUTHENTICATION,
+                                   APP_INDICATOR_CATEGORY_APPLICATION_STATUS);
 
+	app_indicator_set_status (indicator, APP_INDICATOR_STATUS_ACTIVE);
+	app_indicator_set_attention_icon (indicator, GTK_STOCK_DIALOG_AUTHENTICATION);
+
+	refresh_menu();
+#endif
 	create_stash_wizard = new CreateStashWizard ();
+#ifdef HAS_APP_INDICATOR
+	import_stash_wizard = new ImportStashWizardMod ();
+#else
 	import_stash_wizard = new ImportStashWizard ();
+#endif
 	config_dialog = new ConfigDialog ();
+#ifdef HAS_APP_INDICATOR
+	edit_dialog = new EditDialog ();
+#endif
 
 	gtk_main ();
 	
